

SUBROUTINE GINV ( A, AI, NR, NC)
  IMPLICIT NONE
  integer, parameter        :: DP = selected_real_kind(33)
  INTEGER, INTENT(IN)       :: NR, NC
  REAL(KIND=DP), INTENT(IN) :: A(NR,NC)
  REAL(KIND=DP), INTENT(OUT):: AI(NC,NR)
  INTEGER                   :: i, j, k, l, count
  REAL(KIND=DP)             :: temp
  REAL(KIND=DP), ALLOCATABLE, DIMENSION(:,:) :: Apo, Apn, d, c, b, bt, Apot



  DO i=1, NR-1

    IF ( i .EQ. 1 ) THEN
      ALLOCATE(Apo(NC,i))
      count=0
      DO l=1, NC
        IF ( A(1,l) .EQ. 0.0_dp ) THEN
          count=count+1
        END IF
      END DO
      IF ( count .EQ. NC ) THEN
        DO j=1, NC
          Apo(j,1)=A(1,j)
        END DO
      ELSE
        temp=0.0_dp
        DO j=1, NC
          temp=temp+A(1,j)**2
        END DO
        DO j=1, NC
          Apo(j,1)=A(1,j)/temp
        END DO      
      END IF
    END IF


    ALLOCATE(Apn(NC,i+1))  
    ALLOCATE(d(1,i))
    ALLOCATE(c(1,NC))
    ALLOCATE(b(1,NC)) 
    ALLOCATE(bt(NC,1))
    ALLOCATE(Apot(i,NC))

    d(1:1,1:i)=MATMUL(A(i+1:i+1,1:NC),Apo(1:NC,1:i))
    c(1:1,1:NC)=A(i+1:i+1,1:NC)-MATMUL(d(1:1,1:i),A(1:i,1:NC))
    count=0
    DO l=1, NC
      IF ( c(1,l) .EQ. 0.0_dp ) THEN
        count=count+1
      END IF
    END DO
    IF ( count .EQ. NC ) THEN
      DO k=1, NC
        DO l=1, i
          Apot(l,k)=Apo(k,l)
        END DO
      END DO
      temp=0.0_dp
      DO k=1, i
        temp=temp+d(1,k)**2
      END DO
      b(1:1,1:NC)=MATMUL(d(1:1,1:i),Apot(1:i,1:NC))/(1.0_dp+temp)
    ELSE
      temp=0.0
      DO k=1, NC
        temp=temp+c(1,k)**2
      END DO
      b(1:1,1:NC)=c(1:1,1:NC)/temp
    END IF 
    DO l=1, NC
      bt(l,1:1)=b(1:1,l)
    END DO
    Apn(1:NC,1:i)=Apo(1:NC,1:i)-MATMUL(bt(1:NC,1:1),d(1:1,1:i))
    Apn(1:NC,i+1:i+1)=bt(1:NC,1:1)
    DEALLOCATE(Apo)
    DEALLOCATE(Apot)
     
    IF ( i .NE. NR-1 ) THEN
      ALLOCATE(Apo(NC,i+1))
      Apo=Apn      
      DEALLOCATE(Apn)  
      DEALLOCATE(d)
      DEALLOCATE(c)
      DEALLOCATE(b) 
      DEALLOCATE(bt)
    ELSE IF (i .EQ. NR-1) THEN
      AI=Apn
    END IF
  END DO
  
END SUBROUTINE GINV
